Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::SumSymMatrix Class Reference

Class for Matrices which are sum of symmetric matrices. More...

`#include <IpSumSymMatrix.hpp>`

Inheritance diagram for Ipopt::SumSymMatrix:
[legend]

## Public Member Functions
void | SetTerm (Index iterm, Number factor, const SymMatrix &matrix)
| Method for setting term iterm for the sum. More...
void | GetTerm (Index iterm, Number &factor, SmartPtr< const SymMatrix > &matrix) const
| Method for getting term iterm for the sum. More...
Index | NTerms () const
| Return the number of terms. More...
Constructors / Destructors
| SumSymMatrix (const SumSymMatrixSpace *owner_space)
| Constructor, initializing with dimensions of the matrix and the number of terms in the sum. More...
| ~SumSymMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| SumSymMatrix ()
| Default Constructor. More...
| SumSymMatrix (const SumSymMatrix &)
| Copy Constructor. More...
void | operator= (const SumSymMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
std::vector< Number > | factors_
| std::vector storing the factors for each term. More...
std::vector< SmartPtr< const SymMatrix > > | matrices_
| std::vector storing the matrices for each term. More...
const SumSymMatrixSpace * | owner_space_
| Copy of the owner_space as a SumSymMatrixSpace. More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for Matrices which are sum of symmetric matrices.

For each term in the we store the matrix and a factor.

Definition at line 24 of file IpSumSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::SumSymMatrix::SumSymMatrix | ( | const SumSymMatrixSpace * | owner_space | ) |

Constructor, initializing with dimensions of the matrix and the number of terms in the sum.

Ipopt::SumSymMatrix::~SumSymMatrix | ( |  | ) |

Destructor.

Ipopt::SumSymMatrix::SumSymMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::SumSymMatrix::SumSymMatrix | ( | const SumSymMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

void Ipopt::SumSymMatrix::SetTerm | ( | Index | iterm,
|  | Number | factor,
|  | const SymMatrix & | matrix
| ) |  |

Method for setting term iterm for the sum.

Note that counting of terms starts at 0.

void Ipopt::SumSymMatrix::GetTerm | ( | Index | iterm,
|  | Number & | factor,
|  | SmartPtr< const SymMatrix > & | matrix
| ) |  | const

Method for getting term iterm for the sum.

Note that counting of terms starts at 0.

Index Ipopt::SumSymMatrix::NTerms | ( |  | ) | const

Return the number of terms.

virtual void Ipopt::SumSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::SumSymMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::SumSymMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::SumSymMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init
| ) |  | const
| protected virtual

Since the matrix is symmetric, the row and column max norms are identical.

Reimplemented from Ipopt::SymMatrix.

virtual void Ipopt::SumSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::SumSymMatrix::operator= | ( | const SumSymMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

std::vector<Number> Ipopt::SumSymMatrix::factors_
| private

std::vector storing the factors for each term.

Definition at line 93 of file IpSumSymMatrix.hpp.

std::vector<SmartPtr<const SymMatrix> > Ipopt::SumSymMatrix::matrices_
| private

std::vector storing the matrices for each term.

Definition at line 96 of file IpSumSymMatrix.hpp.

const SumSymMatrixSpace* Ipopt::SumSymMatrix::owner_space_
| private

Copy of the owner_space as a SumSymMatrixSpace.

Definition at line 99 of file IpSumSymMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpSumSymMatrix.hpp